
#ifndef X_VIDEO_H
#define X_VIDEO_H 1

/* This prevents the
      /usr/src/linux/include/linux/videodev2.h:378: field `timestamp'
       has incomplete type
 error */
#include <sys/types.h>

/* ?  #include <linux/videodev.h> */
#include "videodev.h"

#define X_MONO_PALETTE  VIDEO_PALETTE_GREY
#define X_MONO_PALETTE_DEPTH  8

/* for V4L2 mmap */
struct mmap_buffer {
   void *start;
   size_t length;
   };

/* capture context */
struct capture_parms {
   int card;
   int fd;
   int chan;
   int has_v4l2;
   unsigned char *buffer;       /* data from read() or mmap() are first moved
                                   here */
   int bufsize;
   unsigned char *yuv2rgbbuf;   /* only allocated if conversion needed */
   struct video_mbuf v_mbuf;
   unsigned char *mbuffer;      /* buffer for mmap() */
   int capx;
   int capy;
   int mono;
   int palette;
   int palette_type;		/* 0=RGB, 1=YUV, 2=Bayer, 3=SPCA561 */
   int depth;
   int quality;
/* V4L2 */
   struct mmap_buffer *mmap_buffers;
   int mmap_n_buffers;
   };

extern struct capture_parms cparms;

void video_init(char *devname, int chan, int mono);
void video_cleanup(void);
void video_alloc_buffers(void);
void video_free_buffers(void);
void video_capture_start(void);
void video_capture_stop(void);
void video_capture_compress(int nojpeg);
void video_change_param(int par, int val);

#endif /* X_VIDEO_H */
